//
//  920MHz LoRa/FSK RF module ES920LR3 
//
//  MaiaR create
//


#include "LoRa.h"

int rxPin;
int txPin;

void LoRaReset(){
  pinMode(rxPin, OUTPUT);
  pinMode(txPin, OUTPUT);
  digitalWrite(rxPin, LOW);
  digitalWrite(txPin, LOW);
  delay(1000);
  pinMode(rxPin, INPUT);
  pinMode(txPin, INPUT);
}


void LoRaConfigMode(){
  Serial.begin(115200);
  while(1){
    LoRaReset();
    Serial1.begin(115200);
    Serial1.setTimeout(50);
    delay(50);
    String rx = Serial1.readString();
    Serial.println(rx);
    if (rx.indexOf("Select Mode [") >= 0) break;
    LoRaCommand("config");
    delay(100); 
  }
}


int LoRaCommand(String s){
  Serial1.print(s + "\r\n");
  Serial1.flush();
  Serial.println(s);
  String rx = Serial1.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}


int LoRaInit(int rx, int tx){
  rxPin = rx;
  txPin = tx;
  LoRaConfigMode();
  if (LoRaCommand("2"     ) < 0) return(-1); // processor mode
  if (LoRaCommand("x"     ) < 0) return(-1); // default
  if (LoRaCommand("b 4"   ) < 0) return(-1); // band width 125kHz
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 1"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
