/********************************************************************************
*
* MCU     : Raspberry Pi Pico
* LoRa    : Conta互換 LoRa無線モジュール ES920LR3搭載
* sensor  : AE-BME280
* library : BME280 by Tyler Glenn
*
********************************************************************************/

//----------------------------------------------------------
// Raspberry Pi Pico
#define SCL_pin 5 // Wire.h
#define SDA_pin 4 // Wire.h
#define RX_pin 1  // Serial1
#define TX_pin 0  // Serial1
//--------------------------------------------------------


#include <BME280I2C.h>
#include <Wire.h>
#include "LoRa.h"

BME280I2C bme;

float temp = 0.0;
float hum = 0.0;
float pres = 0.0;
float pressure = 0.0;

void setup(){
  Serial.begin(115200);
  Wire.end();
  Wire.begin();
  bme.begin();
  LoRaInit(RX_pin, TX_pin);
}

void loop() {
  printBME280Data(&Serial);
  LoRaCommand("MC"+String(temp)+" "+String(hum)+((pressure < 1000)? "  ":" ")+String(pressure));
  delay(5000);
}

//////////////////////////////////////////////////////////////////
void printBME280Data(Stream* client){

   BME280::TempUnit tempUnit(BME280::TempUnit_Celsius);
   BME280::PresUnit presUnit(BME280::PresUnit_Pa);

   bme.read(pres, temp, hum, tempUnit, presUnit);
   pressure = pres / 100;

   client->print("Temp: ");
   client->print(temp);
   client->print("°"+ String(tempUnit == BME280::TempUnit_Celsius ? 'C' :'F'));
   client->print("\t\tHumidity: ");
   client->print(hum);
   client->print("% RH");
   client->print("\t\tPressure: ");
   client->print(pres);
   client->println("Pa");

}